/**
 * Queue.java
 * Created on 28 february 2007, 10:30
 *
 * FIFO queue class, based in the class Queue from Watershed.
 * Some instruction must be modified to run in Java 1.4
 *
 * Copyright (c) 2007 by Manuel Guillermo Forero-Vargas
 * e-mail: mgforero@yahoo.es
 *
 * This class is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this plugin; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.util.*;//Employed to use the LinkedList class

public class Queue
{
    public LinkedList[] queues;
    public int maxPriority,nbElements;
    
    public Queue(int nbQueues)
    {
        queues=new LinkedList[nbQueues];
        maxPriority=0;//The priority is maximal when is zero
        nbElements=0;
    }
    
    //Add an element in the LinkedList which has the highest priority
    public void push(Object o, int priority)//The priority is given by the intensity of the pixel
    {//The darkest pixels have the highest priority, therefore the dark regions
     //will grow first and can become bigger.
        if(priority<=maxPriority)
            maxPriority=priority;
        if(queues[priority]==null)
            queues[priority]=new LinkedList();
        queues[priority].addLast(o);
        nbElements++;
    }
     
    //Return the element which has the highest priority
    public Object pop()
    {
//      Object o=queues[maxPriority].pollFirst();//Get the next element and release it JAVA1.6
        Object o=queues[maxPriority].getFirst();//Get the next element and release it JAVA1.4
        queues[maxPriority].removeFirst();//JAVA1.4
        nbElements--;
        if (queues[maxPriority].isEmpty())
            updatePriority();
        return o;
    }

    //Update the maximum priority
    public void updatePriority()
    {
        while(maxPriority<=255&&(queues[maxPriority]==null||queues[maxPriority].isEmpty()))
            maxPriority++;
    }

    //Return false if notempty
    public boolean notEmpty()
    {
        return nbElements==0?false:true;
    }
}
